# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

BEGIN { $| = 1; print "1..19\n"; }
END {print "not ok 1\n" unless $loaded;}

use ShiftJIS::String qw(:kana :H2Z :Z2H toupper tolower);

$^W = 1;
$loaded = 1;
print "ok 1\n";

######################### End of black magic.

{
my $kataH
 = ''
 . '޷޸޹޺޻޼޽޾޿߳';

my $kataZ
 = 'BuvAE@BDFHb[ACEGIJLNPRTVXZ\^'
 . '`cegijklmnqtwz}~JK'
 . 'KMOQSUWY[]_adfhorux{psvy|';

my $hiraZ
 = 'BuvAE['
 . 'ĂƂȂɂʂ˂̂͂Ђӂւق܂݂ނ߂JK'
 . 'Âłǂ΂тԂׂڂς҂Ղ؂ۂJ';

my $hiraZK
 = ''
 . 'ĂƂȂɂʂ˂̂͂Ђӂւق܂݂ނ߂'
 . 'Âłǂ΂тԂׂڂς҂Ղ؂ۂJ';

my $all = $hiraZ.$kataZ.$kataH;

# 샎Ȃǂ̓eXg珜OB

  my $ary;
  foreach $ary (
    [ \&kataH2Z,  $hiraZ.$kataZ.$kataZ,  89 ],
    [ \&kanaH2Z,  $hiraZ.$kataZ.$kataZ,  89 ],
    [ \&kataZ2H,  $hiraZK.$kataH.$kataH, 97 ],
    [ \&kanaZ2H,  $kataH.$kataH.$kataH, 178 ],
    [ \&hiXka,    $kataZ.$hiraZ.$kataH, 162 ],
    [ \&hi2ka,    $kataZ.$kataZ.$kataH,  81 ],
    [ \&ka2hi,    $hiraZ.$hiraZ.$kataH,  81 ],
    [ \&spaceH2Z, $hiraZ.$kataZ.$kataH,   0 ],
    [ \&spaceZ2H, $hiraZ.$kataZ.$kataH,   0 ],
    [ \&toupper,  $hiraZ.$kataZ.$kataH,   0 ],
    [ \&tolower,  $hiraZ.$kataZ.$kataH,   0 ],
  ) {
    my $ng = 0;
    my $str = $all;
    $ng++ unless &{ $ary->[0] }($all) eq $ary->[1];
    $ng++ unless &{ $ary->[0] }(\$str) eq $ary->[2];
    $ng++ unless $str eq $ary->[1];
    print $ng == 0 ? "ok" : "not ok", " ", ++$loaded, "\n";
  }
}

print hiXka('삩AE') eq 'JPJ삩'
   && ka2hi('삩AE') eq '삩J삩'
   && hi2ka('삩AE') eq 'JPAE'
    ? "ok" : "not ok", " ", ++$loaded, "\n";

{
  my $lo = 'abcdefghijklmnopqrstuvwxyz';
  my $up = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
  my $sp = ' ';
  my $zp = '@';
  my $all = "$sp$lo$zp$up$sp$lo";

  my $ary;
  foreach $ary (
    [ \&toupper,  "$sp$up$zp$up$sp$up", 52 ],
    [ \&tolower,  "$sp$lo$zp$lo$sp$lo", 26 ],
    [ \&spaceH2Z, "$zp$lo$zp$up$zp$lo",  2 ],
    [ \&spaceZ2H, "$sp$lo$sp$up$sp$lo",  1 ],
  ) {
    my $ng = 0;
    my $str = $all;
    $ng++ unless &{ $ary->[0] }($all) eq $ary->[1];
    $ng++ unless &{ $ary->[0] }(\$str) eq $ary->[2];
    $ng++ unless $str eq $ary->[1];
    print $ng == 0 ? "ok" : "not ok", " ", ++$loaded, "\n";
  }
}

{
  my $ng = 0;
  my $ary;
  for $ary (
    [ qw/ 񂿂ɂ 񂿂ɂ   0 / ],
    [ qw/       Rj`n   5 / ],
    [ qw/ ߰       p[       3 / ],
    [ qw/ ۸ь vO 5 / ],
    [ qw/ ޸    r_NI   5 / ],
    [ qw/ ߷߸߹ߺ JKLKNKPKRK 10 / ],
    [ qw/ ޡ       JB       2 / ],
    [ qw/ ޡ        GJB       3 / ],
    [ qw/ AޡB      ABB       2 / ],
  ) {
    my $str = $ary->[0];
    $ng++ unless kanaH2Z($str)  eq $ary->[1];
    $ng++ unless $str eq $ary->[0];
    $ng++ unless kanaH2Z(\$str) eq $ary->[2];
    $ng++ unless $str eq $ary->[1];
  }
  print $ng == 0 ? "ok" : "not ok", " ", ++$loaded, "\n";
}


{
  my $ng = 0;
  my $ary;
  for $ary (
    [ qw/ ABCD񂿂ɂ abcd񂿂ɂ   4 / ],
    [ qw/ At@xbg܂܂Ȃ  At@xbg܂܂Ȃ 0 / ],
    [ qw/ Perl_Module    perl_module   2 / ],
    [ qw/ og og 0 / ],
  ) {
    my $str = $ary->[0];
    $ng++ unless tolower($str)  eq $ary->[1];
    $ng++ unless $str eq $ary->[0];
    $ng++ unless tolower(\$str) eq $ary->[2];
    $ng++ unless $str eq $ary->[1];
  }
  print $ng == 0 ? "ok" : "not ok", " ", ++$loaded, "\n";
}


